function features=extractFeaturesFromKurtosis(assigned_states,pcg_signal)
%
%
%% We just assume that the assigned_states cover at least 2 whole heart beat cycle
indx = find(abs(diff(assigned_states))>0); % find the locations with changed states

if assigned_states(1)>0   % for some recordings, there are state zeros at the beginning of assigned_states
    switch assigned_states(1)
        case 4
            K=1;
        case 3
            K=2;
        case 2
            K=3;
        case 1
            K=4;
    end
else
    switch assigned_states(indx(1)+1)
        case 4
            K=1;
        case 3
            K=2;
        case 2
            K=3;
        case 1
            K=0;
    end
    K=K+1;
end

indx2                = indx(K:end);
rem                  = mod(length(indx2),4);
indx2(end-rem+1:end) = [];
A                    = reshape(indx2,4,length(indx2)/4)'; % A is N*4 matrix, the 4 columns save the beginnings of S1, systole, S2 and diastole in the same heart cycle respectively

sz=size(A);
for cn=1:sz(1)-1
    s1=pcg_signal(A(cn,1):A(cn,2),1);
    s1m4=sum(s1.^4)/length(s1);
    s1m2=(sum(s1.^2)/length(s1)).^2;
    if s1m2==0
        s1_kur(cn,1)=0;
    else
        s1_kur(cn,1)=s1m4/s1m2;
    end
    clear s1;
    
    s2=pcg_signal(A(cn,3):A(cn,4),1);
    s2m4=sum(s2.^4)/length(s2);
    s2m2=(sum(s2.^2)/length(s2)).^2;
    if s2m2==0
        s2_kur(cn,1)=0;
    else
        s2_kur(cn,1)=s2m4/s2m2;
    end
    clear s2;
    
    sys=pcg_signal(A(cn,2):A(cn,3),1);
    sysm4=sum(sys.^4)/length(sys);
    sysm2=(sum(sys.^2)/length(sys)).^2;
    if sysm2==0
        sys_kur(cn,1)=0;
    else
        sys_kur(cn,1)=sysm4/sysm2;
    end
    clear sys;    
    
    dia=pcg_signal(A(cn,4):A(cn+1,1),1);
    diam4=sum(dia.^4)/length(dia);
    diam2=(sum(dia.^2)/length(dia)).^2;
    if diam2==0
        dia_kur(cn,1)=0;
    else
        dia_kur(cn,1)=diam4/diam2;
    end
    clear dia;      
end

features=[mean(s1_kur) std(s1_kur) mean(s2_kur) std(s2_kur) ...
    mean(sys_kur) std(sys_kur) mean(dia_kur) std(dia_kur)];
